﻿package  {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.PixelSnapping;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.events.MouseEvent;
	import flash.display.BlendMode;
	import flash.geom.Rectangle;
	
	public class perlinNoise01 extends Sprite {
		
		public var mc_image:MovieClip;
		public var images:Array;
		public var image_num:Number;
		public var mc_bmp:MovieClip;
		public var img_data:BitmapData;
		public var bmp_data:BitmapData;
		public var bmp_obj:Bitmap;
		public var offset:Array;
		public var octaves:Number = 1;
		public var w:Number = 900;
		public var h:Number = 700;
		public var tw:Number = w/3;
		public var th:Number = h/3;
		public var nw:Number = 0;
		public var nh:Number = 0;
		public var vd:Number = 0;
		public var speed:Array;
		
		public function perlinNoise01() {
			init();
		}
		
		public function init():void {
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			imageSet();
			createBitmap();
			btn_change.addEventListener(MouseEvent.CLICK, imageChange);
		}
		
		public function imageSet() {
			mc_image = new MovieClip();
			ImageBox.addChild(mc_image);
			mc_image.cacheAsBitmap = true;
			
			images = [];
			var img_data01:BitmapData  = new img01(0,0);
			images.push(img_data01);
			var img_data02:BitmapData  = new img02(0,0);
			images.push(img_data02);
			image_num = 0;
			img_data = new BitmapData(w, h, true, 0xFFFFFFFF);
			var img_obj:Bitmap = new Bitmap( img_data , PixelSnapping.AUTO , true);
			img_data.copyPixels(images[image_num], new Rectangle(0, 0, w, h), new Point(0, 0 ));
			mc_image.addChild(img_obj);
			
		}
		
		public function imageChange(e:MouseEvent) {
			
			if (image_num == 0) {
				tw = 100;
				th = 100;
				image_num = 1;
			} else {
				tw = w/3;
				th = h/3;
				image_num = 0;
			}
			
			vd = 0;
			mc_image.addEventListener(Event.ENTER_FRAME, imgEnterFrame);
			
		}
		
		public function imgEnterFrame(e:Event) {
			
			vd += (280 - vd) / 10; 
			if (vd > 255)	{ 
				mc_image.removeEventListener(Event.ENTER_FRAME,imgEnterFrame);
			}
			img_data.merge(images[image_num], new Rectangle(0, 0, w, h), new Point(0, 0 ), vd, vd,vd, vd);
			
		}
		
		public function createBitmap():void {
			mc_bmp = new MovieClip();
			bmp_data = new BitmapData( w , h , true , 0xFFFFFFFF);
			bmp_obj = new Bitmap( bmp_data , PixelSnapping.AUTO ,true);
			ImageBox.addChild(mc_bmp);
			mc_bmp.addChild(bmp_obj);
			mc_bmp.cacheAsBitmap = true;
			//mc_image.mask = mc_bmp;
			//mc_bmp.blendMode = BlendMode.MULTIPLY;
			mc_bmp.blendMode = BlendMode.HARDLIGHT;
			
			
			offset = [];
			speed = [];
			for (var i:Number = 0; i < octaves; i++) {
				offset[i] = new Point(Math.random() * w, Math.random() * h);
				speed[i] = new Point(3, Math.random()*4-2);
			}
			
			this.addEventListener(Event.ENTER_FRAME, bmpEnterFrame);
		}
		
		public function bmpEnterFrame(e:Event):void {
			for (var i:Number = 0; i < octaves; i++) {
					offset[i].x += speed[i].x;
					offset[i].y += speed[i].y;
			}
			
			nw += (tw - nw) / 5;
			nh += (th - nh) / 5;
			
			bmp_data.perlinNoise(nw, nh, octaves, 0, false,true,  0x08 , true, offset);
			
		}
	}
	
}